#ifndef MSP430_HPP_INC_
#define MSP430_HPP_INC_

#include "..\idaidp.hpp"
#include "ins.hpp"
#include <diskio.hpp>

//#define KR_DEBUG_MESSAGES
#ifdef KR_DEBUG_MESSAGES
#ifndef TRACE
#define TRACE   log
#endif 
#else // KR_DEBUG_MESSAGES
#ifndef TRACE
#define TRACE	1 ? (void)0 : log
#endif
#endif // KR_DEBUG_MESSAGES


//------------------------------------------------------------------------
// customization of the 'cmd' structure:

// phrase
enum {
	phrase_ind_reg,
	phrase_ind_reg_inc,
};

// indirect register number (for o_phrase):
#define	indreg     specflag1

// Operand specific flags
// Operand is emulated constant generator immediate
#define OPSPECVAL_CG_FLAG (1<<0)
#define OPSPECVAL_MEMNEAR_FLAG (1<<1)

// Command specific flag
// Command use byte access
#define CMDAUXPREF_BYTE_FLAG (1<<0)

extern ea_t intmem;               // address of the internal memory
extern ea_t sfrmem;               // address of SFR memory

extern char device[MAXSTR];

//------------------------------------------------------------------------
// Registers
enum regnum_t
{
	rPC, rSP, rSR, rCG2, rR4, rR5, rR6, rR7, rR8, rR9, rR10, rR11, R12, R13, R14, R15,
	rVcs, rVds            // these 2 registers are required by the IDA kernel
};

//------------------------------------------------------------------------
void log(const char *format, ...);
//------------------------------------------------------------------
extern netnode helper;

ea_t calc_mem(ea_t ea);         // map virtual to physical ea
const ioport_t *find_sym(int address);
//------------------------------------------------------------------
void interr(const char *module);

void header(void);
void footer(void);

void segstart(ea_t ea);

void out(void);

int ana(void);
int emu(void);

bool outop(op_t &op);
void MSP430_data(ea_t ea);

bool is_branch_instruction (ushort type);
int  is_align_insn(ea_t ea);
bool create_func_frame(func_t *pfn);
void out_rename(ea_t ea,int storage);
int  out_storage_class(ea_t ea);
void gen_stkvar_def(char *buf,const member_t *mptr,long v);
bool is_sp_based(op_t &x);

int get_frame_retsize(func_t *);
int is_jump_func(const func_t *pfn, ea_t *jump_target);
int is_sane_insn(int nocrefs);
int may_be_func(void);           // can a function start here?

#endif
